#ifndef POPREQUEST_H
#define POPREQUEST_H


/* definitions */

#define TRUE 1
#define FALSE 0


/* GNUC on Alpha specials*/

#if defined __GNUC__ && defined __ALPHA
#   define cli$dcl_parse CLI$DCL_PARSE
#   define cli$get_value CLI$GET_VALUE
#   define cli$present CLI$PRESENT
#   define mail$user_begin MAIL$USER_BEGIN
#   define mail$user_end MAIL$USER_END
#   define mail$user_get_info MAIL$USER_GET_INFO
#   define poprequest_cld POPREQUEST_CLD
#   define sys$qiow SYS$QIOW
#endif

/* types */

typedef struct dsc$descriptor_s STR_DESCR;

typedef struct 
{
  char  *option;
  char  ** suboption;
  int   ismultiline;
} xtnd_options_type;

typedef struct
{
   short cond_value;
   short count;
   int info;
} io_statblk;

/* prototypes */

void usage (void);
int connect_to_host (char *remote_hostname, 
                     unsigned int remote_port, int *error_code);
char * get_response (int sockfd, int *status);
char * get_line (int sockfd, int * status);
int login_to_server (int sockfd, char * line);
int disconnect_from_server (int sockfd, int timeout);
int sendprintf (int sockfd, char *format, ...);
int l_printf (char *format, ...);
int l_puts (char *string);
char *readpw (void);
FILE * redir_output (void);
char * read_local_password (void);
char * err_msg (int status);

int execute_pop_command (int sockfd, char * command);
int execute_com_option (int sockfd);
int execute_xtnd_option (int sockfd);
char **extend_xtnd_arg (char *item);

char * create_digest (char * timestamp, char * secret);
char * ParseConfigLine (char * pszLine);
char * Truncate_String (char * pszString);
char * Truncate_Input_Record (char * Record);
char * vms_errmsg (int error_number);
char * lower (char * str);

/* cli parse functions */
void cli_dcl_parse(void);
int cli_present      (char *item);
char *cli_get_value   (char *item);

/* other functions in popcl_cli */
STR_DESCR * desz (char * String);
STR_DESCR * des (char * Buffer, size_t buflen);

#endif /* POPREQUEST_H */
